#include <string.h>
#include <stdlib.h>
#include "ctype.h"
#include "vldtn.h"
#include "helper.h"
#include "vmacros.h"

#define TRUE 1

#define Year1 2007
#define Year2 2008
#define December1YearPre1 "01/12/2006"
#define August1YearPre1 "01/08/2006"
#define August1YearPre14 "01/08/1993"
#define August1Year1 "01/08/2007"
#define December1Year1 "01/12/2007"
#define August1Year2 "01/08/2008"
#define December1Year2 "01/12/2008"
#define Jul1PreYr13 "01/07/1994"
#define Dec1PreYr10 "01/12/1997"
#define August1Year3 "01/08/2009"
int uiNeedsPostcode=1;
int uiNeedsJACScode=1;
SZ szVRVer[]="1.4";
SZ szDateWritten[]="2008-08-11 09:49:33";

#ifdef ANSI
static UINT ValidateField1(void);
static UINT FieldInfo1(int bMacro);
static UINT ValidateField2(void);
static UINT FieldInfo2(int bMacro);
static UINT ValidateField3(void);
static UINT FieldInfo3(int bMacro);
static UINT ValidateField4(void);
static UINT FieldInfo4(int bMacro);
static UINT ValidateField5(void);
static UINT FieldInfo5(int bMacro);
static UINT ValidateField6(void);
static UINT FieldInfo6(int bMacro);
static UINT ValidateField7(void);
static UINT FieldInfo7(int bMacro);
static UINT ValidateField8(void);
static UINT FieldInfo8(int bMacro);
static UINT ValidateField9(void);
static UINT FieldInfo9(int bMacro);
static UINT ValidateField10(void);
static UINT FieldInfo10(int bMacro);
static UINT ValidateField11(void);
static UINT FieldInfo11(int bMacro);
static UINT ValidateField12(void);
static UINT FieldInfo12(int bMacro);
static UINT ValidateField13(void);
static UINT FieldInfo13(int bMacro);
static UINT ValidateField14(void);
static UINT FieldInfo14(int bMacro);
static UINT ValidateField15(void);
static UINT FieldInfo15(int bMacro);
static UINT ValidateField16(void);
static UINT FieldInfo16(int bMacro);
static UINT ValidateField17(void);
static UINT FieldInfo17(int bMacro);
static UINT ValidateField18(void);
static UINT FieldInfo18(int bMacro);
static UINT ValidateField19(void);
static UINT FieldInfo19(int bMacro);
static UINT ValidateField20(void);
static UINT FieldInfo20(int bMacro);
static UINT ValidateField21(void);
static UINT FieldInfo21(int bMacro);
static UINT ValidateField22(void);
static UINT FieldInfo22(int bMacro);
static UINT ValidateField23(void);
static UINT FieldInfo23(int bMacro);
#else
static UINT ValidateField1();
static UINT FieldInfo1();
static UINT ValidateField2();
static UINT FieldInfo2();
static UINT ValidateField3();
static UINT FieldInfo3();
static UINT ValidateField4();
static UINT FieldInfo4();
static UINT ValidateField5();
static UINT FieldInfo5();
static UINT ValidateField6();
static UINT FieldInfo6();
static UINT ValidateField7();
static UINT FieldInfo7();
static UINT ValidateField8();
static UINT FieldInfo8();
static UINT ValidateField9();
static UINT FieldInfo9();
static UINT ValidateField10();
static UINT FieldInfo10();
static UINT ValidateField11();
static UINT FieldInfo11();
static UINT ValidateField12();
static UINT FieldInfo12();
static UINT ValidateField13();
static UINT FieldInfo13();
static UINT ValidateField14();
static UINT FieldInfo14();
static UINT ValidateField15();
static UINT FieldInfo15();
static UINT ValidateField16();
static UINT FieldInfo16();
static UINT ValidateField17();
static UINT FieldInfo17();
static UINT ValidateField18();
static UINT FieldInfo18();
static UINT ValidateField19();
static UINT FieldInfo19();
static UINT ValidateField20();
static UINT FieldInfo20();
static UINT ValidateField21();
static UINT FieldInfo21();
static UINT ValidateField22();
static UINT FieldInfo22();
static UINT ValidateField23();
static UINT FieldInfo23();
#endif

struct FLD stFields[]={
	{1,"RECID",1,5,0,1,ValidateField1,FieldInfo1,0,0,NULL,0},
	{2,"INSTID",1,4,5,1,ValidateField2,FieldInfo2,0,0,NULL,0},
	{3,"STAFFID",1,13,9,1,ValidateField3,FieldInfo3,0,0,NULL,0},
	{4,"BIRTHDTE",1,8,22,1,ValidateField4,FieldInfo4,0,0,NULL,0},
	{5,"GENDER",1,1,30,1,ValidateField5,FieldInfo5,0,0,NULL,0},
	{6,"NATION",1,4,31,1,ValidateField6,FieldInfo6,0,0,NULL,0},
	{7,"ETHNIC",0,2,35,1,ValidateField7,FieldInfo7,0,0,NULL,0},
	{8,"NATID1",1,1,37,1,ValidateField8,FieldInfo8,0,0,NULL,0},
	{9,"NATID2",1,1,38,1,ValidateField9,FieldInfo9,0,0,NULL,0},
	{10,"DISABLED",1,1,39,1,ValidateField10,FieldInfo10,0,0,NULL,0},
	{11,"DATEFHEI",1,8,40,1,ValidateField11,FieldInfo11,0,0,NULL,0},
	{12,"PREVEMP",1,2,48,1,ValidateField12,FieldInfo12,0,0,NULL,0},
	{13,"PREVHEI",1,4,50,1,ValidateField13,FieldInfo13,0,0,NULL,0},
	{14,"HQHELD",1,2,54,1,ValidateField14,FieldInfo14,0,0,NULL,0},
	{15,"ACCDIS1",1,4,56,1,ValidateField15,FieldInfo15,0,0,NULL,0},
	{16,"ACCDIS2",1,4,60,1,ValidateField16,FieldInfo16,0,0,NULL,0},
	{17,"REGBODY",1,2,64,1,ValidateField17,FieldInfo17,0,0,NULL,0},
	{18,"ABLWELSH",1,1,66,1,ValidateField18,FieldInfo18,0,0,NULL,0},
	{19,"DATELEFT",1,8,67,1,ValidateField19,FieldInfo19,0,0,NULL,0},
	{20,"LEDEST",1,2,75,1,ValidateField20,FieldInfo20,0,0,NULL,0},
	{21,"RESACT",1,1,77,1,ValidateField21,FieldInfo21,0,0,NULL,0},
	{22,"UOA",1,3,78,1,ValidateField22,FieldInfo22,0,0,NULL,0},
	{23,"TOTSAL",1,7,81,1,ValidateField23,FieldInfo23,0,0,NULL,0},
	};


struct ERROR stErrors[]={
	{1,33603,99,0},
	{2,33604,99,0},
	{3,33607,99,0},
	{3,33606,99,0},
	{3,33605,99,0},
	{3,33559,99,0},
	{3,33610,99,0},
	{3,33560,99,0},
	{4,33562,99,0},
	{4,33563,99,0},
	{4,33564,99,0},
	{5,33565,99,0},
	{6,33566,99,0},
	{7,33568,99,0},
	{7,33569,99,0},
	{7,33567,99,0},
	{8,33570,99,0},
	{8,33571,99,0},
	{8,33572,99,0},
	{8,33573,99,0},
	{9,33575,99,0},
	{9,33576,99,0},
	{9,33574,99,0},
	{10,33577,99,0},
	{11,33580,99,0},
	{11,33579,99,0},
	{11,33578,99,0},
	{12,33581,99,0},
	{12,33601,99,0},
	{13,33602,99,0},
	{13,33582,99,0},
	{14,33583,99,0},
	{15,33585,99,0},
	{15,33584,99,0},
	{16,33586,99,0},
	{16,33587,99,0},
	{16,33588,99,0},
	{17,33589,99,0},
	{18,33590,99,0},
	{18,33591,99,0},
	{19,33592,99,0},
	{19,33595,99,0},
	{19,33593,99,0},
	{19,33594,99,0},
	{20,33596,99,0},
	{21,33597,99,0},
	{22,33598,99,0},
	{22,33599,99,0},
	{23,33600,99,0},
	};

UINT uiRNo=25;
SZ szLRNo[]="07025";
UINT uiRLength=88;
UINT uinFields=23;
UINT uinRules=49;
UINT uiSeverity=0;
SZ szValidFile[]="07025va.csv";
SZ szErrorFile[]="07025.err";
SZ szBinFile[]="07025.bin";
SZ szError1File[]=".ERRORS";
SZ szLongDescFile[]=".RULES";
SZ szWarningFile[]=".WARNINGS";
SZ szTotalsFile[]=".SUMMARY";
SZ szInfoFile[]=".INF";
SZ szExplanErrFile[]="07025rl.csv";
UINT uiKeyField=2;

#define _RECID_ 0
#define _INSTID_ 1
#define _STAFFID_ 2
#define _BIRTHDTE_ 3
#define _GENDER_ 4
#define _NATION_ 5
#define _ETHNIC_ 6
#define _NATID1_ 7
#define _NATID2_ 8
#define _DISABLED_ 9
#define _DATEFHEI_ 10
#define _PREVEMP_ 11
#define _PREVHEI_ 12
#define _HQHELD_ 13
#define _ACCDIS1_ 14
#define _ACCDIS2_ 15
#define _REGBODY_ 16
#define _ABLWELSH_ 17
#define _DATELEFT_ 18
#define _LEDEST_ 19
#define _RESACT_ 20
#define _UOA_ 21
#define _TOTSAL_ 22
int OwnStuId = 1;
int OwnPsdId = 1;


#ifdef ANSI
static UINT FieldInfo1(int bMacro)
#else 
static UINT FieldInfo1(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField1(void)
#else 
static UINT ValidateField1()
#endif 
{
uiSeverity=0;
if ((!(M_ISFIELD(uiCurFieldNo,"07025"))) && (!IgnoreRule(33603))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain 07025.");
	return 33603;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo2(int bMacro)
#else 
static UINT FieldInfo2(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField2(void)
#else 
static UINT ValidateField2()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33604))) {
	uiSeverity=99;
	strcpy(RuleText,"The field must contain a valid current HESA HE institution identifier (see coding manual for all valid entries).");
	return 33604;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo3(int bMacro)
#else 
static UINT FieldInfo3(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField3(void)
#else 
static UINT ValidateField3()
#endif 
{
uiSeverity=0;
if ((!(IsFormat(uiCurFieldNo,"AAAAAAAAAAAAA") ?  M_TRUE 
: M_FALSE)) && (!IgnoreRule(33559))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain exactly 13 characters");
	return 33559;
	}
if ((!(((M_STRCMP(M_GETFIELDN(uiCurFieldNo,0,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,0,1),"9")<=0) && 
(M_STRCMP(M_GETFIELDN(uiCurFieldNo,1,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,1,1),"9")<=0)) || 
(M_ISFIELDN(uiCurFieldNo,"X",0,1) && M_ISFIELDN(uiCurFieldNo,"X",1,1)))) && (!IgnoreRule(33560))) {
	uiSeverity=99;
	strcpy(RuleText,"Characters 1 and 2 of this field must be numeric or XX.");
	return 33560;
	}
if ((!(M_LOOKUPN(uiCurFieldNo,2,4,HISTORICSTAFFINST) || 
(
(M_STRCMP(M_GETFIELDN(uiCurFieldNo,2,1),"0")==0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,3,1),"0")==0) && 
(M_STRCMP(M_GETFIELDN(uiCurFieldNo,4,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,4,1),"9")<=0 &&
M_STRCMP(M_GETFIELDN(uiCurFieldNo,5,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,5,1),"9")<=0) 
))) && (!IgnoreRule(33605))) {
	uiSeverity=99;
	strcpy(RuleText,"Characters 3 to 6 of this field must be ((a current or historic HESA HE institution identifier plus 1000) or (if characters 3 and 4 are 00 then 5 and 6 must be numeric)).");
	return 33605;
	}
if ((!((M_STRCMP(M_GETFIELDN(uiCurFieldNo,6,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,6,1),"9")<=0) && 
(M_STRCMP(M_GETFIELDN(uiCurFieldNo,7,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,7,1),"9")<=0) && 
(M_STRCMP(M_GETFIELDN(uiCurFieldNo,8,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,8,1),"9")<=0) && 
(M_STRCMP(M_GETFIELDN(uiCurFieldNo,9,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,9,1),"9")<=0) && 
(M_STRCMP(M_GETFIELDN(uiCurFieldNo,10,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,10,1),"9")<=0) && 
(M_STRCMP(M_GETFIELDN(uiCurFieldNo,11,1),"0")>=0 && M_STRCMP(M_GETFIELDN(uiCurFieldNo,11,1),"9")<=0))) && (!IgnoreRule(33606))) {
	uiSeverity=99;
	strcpy(RuleText,"Characters 7 to 12 of this field must be numeric.");
	return 33606;
	}
if ((!(ChecksumOK(uiCurFieldNo))) && (!IgnoreRule(33607))) {
	uiSeverity=99;
	strcpy(RuleText,"Character 13 of this field must pass the checksum test given in the coding manual.");
	return 33607;
	}
if ((!(!M_ISFIELD(uiCurFieldNo,"0000000000000"))) && (!IgnoreRule(33610))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must not contain all zeroes.");
	return 33610;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo4(int bMacro)
#else 
static UINT FieldInfo4(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField4(void)
#else 
static UINT ValidateField4()
#endif 
{
uiSeverity=0;
if ((!(M_VALID8DIGITDATE|| _DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L)) && (!IgnoreRule(33562))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a date in the format YYYYMMDD, or be 99991231 or 19010101.");
	return 33562;
	}
if ((!(!(_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L ) ? 
(_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo), "01/08/1992") < 0L): M_TRUE)) && (!IgnoreRule(33563))) {
	uiSeverity=99;
	strcpy(RuleText,"If BIRTHDTE<>99991231 or <>19010101 then BIRTHDTE must be before 19920801.");
	return 33563;
	}
if ((!(!(
(_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L ) 
|| (_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"01/01/1901")==0L )
)? 
(_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo), "31/07/1917") > 0L): M_TRUE)) && (!IgnoreRule(33564))) {
	uiSeverity=99;
	strcpy(RuleText,"If BIRTHDTE<>99991231 or <>19010101 then BIRTHDTE must be after 19170731.");
	return 33564;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo5(int bMacro)
#else 
static UINT FieldInfo5(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField5(void)
#else 
static UINT ValidateField5()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33565))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33565;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo6(int bMacro)
#else 
static UINT FieldInfo6(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField6(void)
#else 
static UINT ValidateField6()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE && !(
M_ISFIELD(_NATION_,"5826")  ||
M_ISFIELD(_NATION_,"6826")  ||
M_ISFIELD(_NATION_,"7826")  ||
M_ISFIELD(_NATION_,"8826")
))) && (!IgnoreRule(33566))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code (see coding manual for all valid entries) with the exception of 5826, 6826, 7826 and 8826.");
	return 33566;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo7(int bMacro)
#else 
static UINT FieldInfo7(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField7(void)
#else 
static UINT ValidateField7()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33567))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33567;
	}
if ((!((M_ENGLISH || M_WELSH || M_NIRISH)? 
(!M_ISFIELD(uiCurFieldNo,"13")): M_TRUE)) && (!IgnoreRule(33568))) {
	uiSeverity=99;
	strcpy(RuleText,"If this institution is in England, Wales or Northern Ireland then this field must not be 13.");
	return 33568;
	}
if ((!((M_ENGLISH || M_WELSH || M_SCOTTISH)? 
(!M_ISFIELD(uiCurFieldNo,"14")): M_TRUE)) && (!IgnoreRule(33569))) {
	uiSeverity=99;
	strcpy(RuleText,"If this institution is in England, Wales or Scotland then this field must not be 14.");
	return 33569;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo8(int bMacro)
#else 
static UINT FieldInfo8(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField8(void)
#else 
static UINT ValidateField8()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33570))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33570;
	}
if ((!(M_WELSH ? !M_ISFIELD(uiCurFieldNo,"X"): M_TRUE)) && (!IgnoreRule(33571))) {
	uiSeverity=99;
	strcpy(RuleText,"If this institution is in Wales then this field must not be X.");
	return 33571;
	}
if ((!((
M_ISFIELD(_NATID2_,"B") ||
M_ISFIELD(_NATID2_,"E") ||
M_ISFIELD(_NATID2_,"I") ||
M_ISFIELD(_NATID2_,"O") ||
M_ISFIELD(_NATID2_,"S") ||
M_ISFIELD(_NATID2_,"W")
) ? !(M_ISFIELD(uiCurFieldNo,"X") ||
M_ISFIELD(uiCurFieldNo,"R") ||
M_ISFIELD(uiCurFieldNo,"U")
): M_TRUE)) && (!IgnoreRule(33572))) {
	uiSeverity=99;
	strcpy(RuleText,"If NATID2=B,E,I,O,S or W then this field must not be X,R or U.");
	return 33572;
	}
if ((!((M_ENGLISH || M_SCOTTISH || M_NIRISH) ? M_ISFIELD(uiCurFieldNo,"X"): M_TRUE)) && (!IgnoreRule(33573))) {
	uiSeverity=99;
	strcpy(RuleText,"If this institution is in England, Scotland or Northern Ireland then this field must be X.");
	return 33573;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo9(int bMacro)
#else 
static UINT FieldInfo9(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField9(void)
#else 
static UINT ValidateField9()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33574))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33574;
	}
if ((!(!M_WELSH ? M_ISFIELD(uiCurFieldNo,"X"): M_TRUE)) && (!IgnoreRule(33575))) {
	uiSeverity=99;
	strcpy(RuleText,"If this institution is in England, Scotland or Northern Ireland then this field must be X.");
	return 33575;
	}
if ((!(M_ISFIELD(_NATID1_,"X") || 
M_ISFIELD(_NATID1_,"R") || 
M_ISFIELD(_NATID1_,"U") ? M_ISFIELD(uiCurFieldNo,"X"): M_TRUE)) && (!IgnoreRule(33576))) {
	uiSeverity=99;
	strcpy(RuleText,"If NATID1=X, R or U then this field must be X.");
	return 33576;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo10(int bMacro)
#else 
static UINT FieldInfo10(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField10(void)
#else 
static UINT ValidateField10()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33577))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33577;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo11(int bMacro)
#else 
static UINT FieldInfo11(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField11(void)
#else 
static UINT ValidateField11()
#endif 
{
uiSeverity=0;
if ((!(M_VALID8DIGITDATE|| _DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L)) && (!IgnoreRule(33578))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a date in the format YYYYMMDD, or be 99991231.");
	return 33578;
	}
if ((!(!(_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L) ? 
(_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo), August1Year2) < 0L): M_TRUE)) && (!IgnoreRule(33579))) {
	uiSeverity=99;
	strcpy(RuleText,"If this field<>99991231 then the date in this field must be before or equal to 31st July of the reporting period.");
	return 33579;
	}
if ((!((!_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L && !_DateDiff(DAY,GetFieldNoDate(_BIRTHDTE_),"31/12/9999")==0L) ? 
GetFieldNoInteger(uiCurFieldNo) > GetFieldNoInteger(_BIRTHDTE_) : M_TRUE)) && (!IgnoreRule(33580))) {
	uiSeverity=99;
	strcpy(RuleText,"If this field<>99991231 (and BIRTHDTE<>99991231) then the date in this field must be after the date returned in BIRTHDTE.");
	return 33580;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo12(int bMacro)
#else 
static UINT FieldInfo12(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField12(void)
#else 
static UINT ValidateField12()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33581))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33581;
	}
if ((!(!M_ISFIELD(_PREVHEI_,"XXXX") ? M_ISFIELD(uiCurFieldNo,"01") || M_ISFIELD(uiCurFieldNo,"21") : M_TRUE)) && (!IgnoreRule(33601))) {
	uiSeverity=99;
	strcpy(RuleText,"If PREVHEI<>XXXX then this field must be 01 or 21.");
	return 33601;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo13(int bMacro)
#else 
static UINT FieldInfo13(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField13(void)
#else 
static UINT ValidateField13()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE || M_ISFIELD(uiCurFieldNo,"XXXX") || M_ISFIELD(uiCurFieldNo,"4001"))) && (!IgnoreRule(33582))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code or XXXX or 4001 (see coding manual for all valid entries).");
	return 33582;
	}
if ((!((
M_ISFIELD(_PREVEMP_,"02") || 
M_ISFIELD(_PREVEMP_,"03") || 
M_ISFIELD(_PREVEMP_,"04") || 
M_ISFIELD(_PREVEMP_,"05") || 
M_ISFIELD(_PREVEMP_,"06") || 
M_ISFIELD(_PREVEMP_,"07") || 
M_ISFIELD(_PREVEMP_,"08") || 
M_ISFIELD(_PREVEMP_,"09") || 
M_ISFIELD(_PREVEMP_,"10") || 
M_ISFIELD(_PREVEMP_,"11") || 
M_ISFIELD(_PREVEMP_,"12") || 
M_ISFIELD(_PREVEMP_,"13") || 
M_ISFIELD(_PREVEMP_,"14") || 
M_ISFIELD(_PREVEMP_,"15") || 
M_ISFIELD(_PREVEMP_,"99") || 
M_ISFIELD(_PREVEMP_,"XX")
) ? M_ISFIELD(uiCurFieldNo,"XXXX") : M_TRUE)) && (!IgnoreRule(33602))) {
	uiSeverity=99;
	strcpy(RuleText,"If PREVEMP = 02-15, 99 or XX then this field must be XXXX.");
	return 33602;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo14(int bMacro)
#else 
static UINT FieldInfo14(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField14(void)
#else 
static UINT ValidateField14()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33583))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33583;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo15(int bMacro)
#else 
static UINT FieldInfo15(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField15(void)
#else 
static UINT ValidateField15()
#endif 
{
uiSeverity=0;
if ((!(IsValidJacsCode6_AnyJust(uiCurFieldNo) || M_ISFIELD(uiCurFieldNo,"XXXX"))) && (!IgnoreRule(33584))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid JACS code or XXXX.");
	return 33584;
	}
if ((!((
M_ISFIELD(_HQHELD_,"31") || 
M_ISFIELD(_HQHELD_,"32") || 
M_ISFIELD(_HQHELD_,"97") || 
M_ISFIELD(_HQHELD_,"98") || 
M_ISFIELD(_HQHELD_,"99") || 
M_ISFIELD(_HQHELD_,"XX")
) ? M_ISFIELD(uiCurFieldNo,"XXXX") : M_TRUE)) && (!IgnoreRule(33585))) {
	uiSeverity=99;
	strcpy(RuleText,"If HQHELD is 31,32,97,98,99 or XX then this field must be XXXX.");
	return 33585;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo16(int bMacro)
#else 
static UINT FieldInfo16(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField16(void)
#else 
static UINT ValidateField16()
#endif 
{
uiSeverity=0;
if ((!(IsValidJacsCode6_AnyJust(uiCurFieldNo) || M_ISFIELD(uiCurFieldNo,"XXXX"))) && (!IgnoreRule(33586))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid JACS code or XXXX.");
	return 33586;
	}
if ((!(M_ISFIELD(_ACCDIS1_,"XXXX") ? 
M_ISFIELD(uiCurFieldNo,"XXXX") : M_TRUE)) && (!IgnoreRule(33587))) {
	uiSeverity=99;
	strcpy(RuleText,"If ACCDIS1=XXXX then this field must be XXXX.");
	return 33587;
	}
if ((!((
M_ISFIELD(_HQHELD_,"31") || 
M_ISFIELD(_HQHELD_,"32") || 
M_ISFIELD(_HQHELD_,"97") || 
M_ISFIELD(_HQHELD_,"98") || 
M_ISFIELD(_HQHELD_,"99") || 
M_ISFIELD(_HQHELD_,"XX")
) ? M_ISFIELD(uiCurFieldNo,"XXXX") : M_TRUE)) && (!IgnoreRule(33588))) {
	uiSeverity=99;
	strcpy(RuleText,"If HQHELD is 31,32,97,98,99 or XX then this field must be XXXX.");
	return 33588;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo17(int bMacro)
#else 
static UINT FieldInfo17(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField17(void)
#else 
static UINT ValidateField17()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33589))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33589;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo18(int bMacro)
#else 
static UINT FieldInfo18(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField18(void)
#else 
static UINT ValidateField18()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33590))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33590;
	}
if ((!((M_ENGLISH || M_SCOTTISH || M_NIRISH) ? M_ISFIELD(uiCurFieldNo,"X") : M_TRUE)) && (!IgnoreRule(33591))) {
	uiSeverity=99;
	strcpy(RuleText,"If this institution is in England, Scotland or Nothern Ireland then this field must be X.");
	return 33591;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo19(int bMacro)
#else 
static UINT FieldInfo19(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField19(void)
#else 
static UINT ValidateField19()
#endif 
{
uiSeverity=0;
if ((!(M_VALID8DIGITDATE)) && (!IgnoreRule(33592))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a date in the format YYYYMMDD.");
	return 33592;
	}
if ((!(((_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo), "31/07/2006") >= 0L) && (_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo), "31/07/2008") <= 0L)) || (_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L))) && (!IgnoreRule(33593))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid date between 20060731 and 20080731 (inclusive) or 99991231");
	return 33593;
	}
if ((!((IsValidInteger(_LEDEST_,01L,15L) || 
IsValidInteger(_LEDEST_,21L,22L) || 
M_ISFIELD(_LEDEST_,"31") || M_ISFIELD(_LEDEST_,"99")) ? !(_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L) : M_TRUE)) && (!IgnoreRule(33594))) {
	uiSeverity=99;
	strcpy(RuleText,"If LEDEST=01-15, 21,22,31 or 99 then this field must not be 99991231.");
	return 33594;
	}
if ((!(!(_DateDiff(DAY,GetFieldNoDate(uiCurFieldNo),"31/12/9999")==0L) &&  !(_DateDiff(DAY,GetFieldNoDate(_DATEFHEI_),"31/12/9999")==0L) ? GetFieldNoInteger(uiCurFieldNo) >=  GetFieldNoInteger(_DATEFHEI_) : M_TRUE)) && (!IgnoreRule(33595))) {
	uiSeverity=99;
	strcpy(RuleText,"If this field <> 99991231 (and DATEFHEI<>99991231) then the date in this field must be equal to or after the date returned in DATEFHEI.");
	return 33595;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo20(int bMacro)
#else 
static UINT FieldInfo20(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField20(void)
#else 
static UINT ValidateField20()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33596))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33596;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo21(int bMacro)
#else 
static UINT FieldInfo21(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField21(void)
#else 
static UINT ValidateField21()
#endif 
{
uiSeverity=0;
if ((!(M_VALIDCODE)) && (!IgnoreRule(33597))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code.");
	return 33597;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo22(int bMacro)
#else 
static UINT FieldInfo22(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField22(void)
#else 
static UINT ValidateField22()
#endif 
{
uiSeverity=0;
if ((!(M_ISFIELD(uiCurFieldNo,"XXX") || IsValidCodeForField(_UOA_,GetFieldNoStringMid(uiCurFieldNo,0,2)) && (( 
(M_STRCMP(M_GETFIELDN(_UOA_,2,1),"A")==0) ||(M_STRCMP(M_GETFIELDN(_UOA_,2,1),"B")==0) 
||(M_STRCMP(M_GETFIELDN(_UOA_,2,1),"C")==0) ||(M_STRCMP(M_GETFIELDN(_UOA_,2,1),"Z")==0) 
)))) && (!IgnoreRule(33598))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain a valid code consisting of a two-digit number (in the range 01 - 67 or 99) or XXX. The two-digit number must be followed by a letter in the range of A,B,C or Z.");
	return 33598;
	}
if ((!(IsValidInteger(_RESACT_,1L,2L) ? !M_ISFIELD(uiCurFieldNo,"XXX") : M_TRUE)) && (!IgnoreRule(33599))) {
	uiSeverity=99;
	strcpy(RuleText,"If RESACT=1 or 2 then this field must not be XXX.");
	return 33599;
	}
return 0;
}

#ifdef ANSI
static UINT FieldInfo23(int bMacro)
#else 
static UINT FieldInfo23(bMacro)
int bMacro;
#endif 
{
if (!bMacro) {	return TRUE;
}
return 0;
}

#ifdef ANSI
static UINT ValidateField23(void)
#else 
static UINT ValidateField23()
#endif 
{
uiSeverity=0;
if ((!(M_ISFIELD(uiCurFieldNo, "9999999"))) && (!IgnoreRule(33600))) {
	uiSeverity=99;
	strcpy(RuleText,"This field must contain 9999999.");
	return 33600;
	}
return 0;
}
